$(function () {
	var AjaxHandler = new AjaxHandle();
	AjaxHandler.init();
});


class AjaxHandle {

	OffsetInput = $(".offset-input");
	OffsetInitial = this.OffsetInput.val();
	Offset = this.OffsetInput.val();
  CategoryInput = $(".category-input-stories");
  Category = this.CategoryInput.val();

	Data;

	PhpAction = "story_ajax_handle";

	Container = $(".slider-signpost-section__row--list");
	ContainerLoadMore = $(".slider-signpost-section__row--list");
	ContainerButtonLoadMore = $(".loadMoreButton");
	ButtonLoadMore = $(".load-more");

	//* Getters

	getData() {
		return this.Data;
	}

	//* Setters

	setOffset(Offset) {
		return this.Offset = Offset;
	}

  setCategory(Category) {
    return this.Category = Category;
  }

	//* public functions

	showContainerButtonLoadMore() {
		this.ContainerButtonLoadMore.removeClass("d-none");
	}

	hideContainerButtonLoadMore() {
		this.ContainerButtonLoadMore.addClass("d-none");
	}

	showLoading() {
    let body = document.body;
    body.classList.add("loading");
    this.ButtonLoadMore.addClass("btn-loading");
	}

	hideLoading() {
    let body = document.body;
    body.classList.remove("loading");
    this.ButtonLoadMore.removeClass("btn-loading");
  }

	loadMoreClickAction() {
		var self = this;
		this.ButtonLoadMore.click(function (e) {
			e.preventDefault();
			self.loadMore();
		});
	}

	loadMore() {
		this.initArgs();
		var self = this;

		$.ajax({
			type: "POST",
			url: myAjax.ajaxurl,
			data: this.getData(),
			beforeSend: function () {
				self.showLoading();
			},
			success: function (response) {
				self.ContainerLoadMore.html(self.ContainerLoadMore.html() + response);
				var newOffset = parseInt(self.Offset) + parseInt(self.OffsetInitial);
				self.OffsetInput.val(newOffset);
				self.setOffset(newOffset);
				self.isLoadMore();
				console.log(response);

			},
			complete: function () {
				self.hideLoading();
			}
		});

	}


	isLoadMore() {

		this.initArgs();
		var self = this;

		$.ajax({
			type: "POST",
			url: myAjax.ajaxurl,
			data: this.getData(),

			success: function (response) {
				if (!$.trim(response)) {
					// response is blank
					self.hideContainerButtonLoadMore();

				} else {
					self.showContainerButtonLoadMore();

				}
			}

		});
	}

	/**
	 * @param bool withOffset
	 */
	initArgs() {
		this.Data = {
			action: this.PhpAction,
		};
		this.setOffset(this.OffsetInput.val());
		this.Data.ajax_offset = this.Offset;
    this.setCategory(this.CategoryInput.val());
    this.Data.ajax_category = this.Category;
	}

	init() {
		this.isLoadMore();
		this.loadMoreClickAction();
	}


}
